/******************************************************************************
* DISCLAIMER

* This software is supplied by Renesas Technology Corp. and is only 
* intended for use with Renesas products. No other uses are authorized.

* This software is owned by Renesas Technology Corp. and is protected under 
* all applicable laws, including copyright laws.

* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES
* REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, 
* INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
* PARTICULAR PURPOSE AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY 
* DISCLAIMED.

* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* TECHNOLOGY CORP. NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES 
* FOR ANY REASON RELATED TO THE THIS SOFTWARE, EVEN IF RENESAS OR ITS 
* AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

* Renesas reserves the right, without notice, to make changes to this 
* software and to discontinue the availability of this software.  
* By using this software, you agree to the additional terms and 
* conditions found by accessing the following link:
* http://www.renesas.com/disclaimer
******************************************************************************
* Copyright (C) 2008. Renesas Technology Corp., All Rights Reserved.
*******************************************************************************	
* File Name    : user-app.c
* Version      : 1.00
* Description  : User application that controls the LEDs from a Web page
******************************************************************************
* History : DD.MM.YYYY Version Description
*         : 06.10.2009 1.00    First Release
*         : 06.04.2010 1.01    RX62N changes
******************************************************************************/


/******************************************************************************
Includes   <System Includes> , "Project Includes"
******************************************************************************/
#include <string.h>
#include "iodefine.h"
#include "user-app.h"
#include "uip.h"

/******************************************************************************
Typedef definitions
******************************************************************************/

/******************************************************************************
Macro definitions
******************************************************************************/

/******************************************************************************
Imported global variables and functions (from other files)
******************************************************************************/

/******************************************************************************
Exported global variables and functions (to be accessed by other files)
******************************************************************************/

/******************************************************************************
Private global variables and functions
******************************************************************************/


/**
 * Device specific configutation parameters in flash are defined here.               
 * These parameters can be serial number, model name, etc.                           
 *                                                                                   
 * The size of this section is 64 bytes and all members must be                      
 * defined as constants.                                                             
 *                                                                                   
 * Name              Size (bytes)    Info                                            
 * -----            --------------  ------                                           
 * my_mac              6             Must be unique per device                       
 * my_ip               4             Default IP address if DHCP server not available 
 * my_netmask          4             Default net mask                                
 * my_default_router   4             Default router address                          
 */
#pragma section _FLASH_CONFIG_PARAMS

// MAC address configuration
const struct uip_eth_addr my_mac = {{0x??, 0x??, 0x??, 0x??, 0x??, 0x??}};

// Default IP address configuration
// Please make sure this IP address in the same subnet with the DHCP server
const u8_t my_ip[4]             = {192, 168, 1, 10};
const u8_t my_netmask[4]        = {255, 255, 255, 0};
const u8_t my_default_router[4] = {192, 168, 1, 1};
const u8_t my_dnsaddr[4]        = {192, 168, 1, 1};

// Reserved 
const u8_t reserved[46] = {0};
