#include <kernel.h>
#include "kernel_cfg.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "uip.h"
#include "httpd-fsdata.h"
extern struct httpd_fsdata_file_noconst * HTTPD_FS_ROOT;

static PT_THREAD(webcam(struct httpd_state *s));
static PT_THREAD(form(struct httpd_state *s));
static PT_THREAD(webcmd(struct httpd_state *s));

PT_THREAD(user_app(struct httpd_state *s))
{
  char* p;

  PT_BEGIN(&s->user_app);

  if (strchr(s->inputbuf, '?') !=NULL)
  {
    PT_WAIT_THREAD(&s->user_app, webcmd(s));
    *strchr(s->inputbuf, '?') = '\0';
    *strchr(s->filename, '?') = '\0';
  }

  p = strstr(s->inputbuf, "/webcam.html");
  if (p != NULL
  &&  strlen(p) == strlen("/webcam.html"))
  {
    PT_WAIT_THREAD(&s->user_app, form(s));
  }

  if (strstr(s->inputbuf, "/webcam.jpg") !=NULL)
  {
    PT_WAIT_THREAD(&s->user_app, webcam(s));
  }

  PT_END(&s->user_app);
}

static struct httpd_fsdata_file_noconst *find_httpd_fsdata(char *name)
{
	struct httpd_fsdata_file_noconst *f;
	struct httpd_fsdata_file_noconst *f_tail = (struct httpd_fsdata_file_noconst *)&HTTPD_FS_ROOT;

	for(f = (struct httpd_fsdata_file_noconst *)HTTPD_FS_ROOT;
		f != NULL;
		f = (struct httpd_fsdata_file_noconst *)f->next)
	{
		if(strcmp(name, f->name) == 0)
		{
			if(strlen(name) == strlen(f->name))
			{
				return f;
			}
		}
		f_tail = f;
	}
	//XgɖƂ̓J[h𒲂ׂ
	char nname[128];int n = 0;
	while(name[n] && name[n] != '\r' && name[n] != '\n'){nname[n] = name[n];n++;}nname[n] = '\0';
	if(E_OK == snd_dtq(DTQ_FF, (intptr_t)nname))
	{
		char *data;
		long len;
		rcv_dtq(DTQ_FF_ACK, (intptr_t*)&data);
		rcv_dtq(DTQ_FF_ACK, (intptr_t*)&len);
		if(data && len)
		{
			//J[hɂ΃Xǧ[ɒǉ
			f_tail->next = (struct httpd_fsdata_file *)calloc(sizeof(struct httpd_fsdata_file_noconst), 1);
			if(f_tail->next)
			{
				f_tail = (struct httpd_fsdata_file_noconst *)f_tail->next;
				f_tail->name = (char*)malloc(strlen(nname) + 1);
				if(f_tail->name)
				{
					sprintf(f_tail->name, "%s", nname);
				}
				f_tail->data = data;
				f_tail->len = len;
				return f_tail;
			}
		}
	}
	return 0;
}

static PT_THREAD(webcam(struct httpd_state *s))
{
	char *name = s->inputbuf;
	struct httpd_fsdata_file_noconst *f = find_httpd_fsdata(name);

	PT_BEGIN(&s->webcam);

	if(f)
	{
		if(f->data)
		{
			//ȑOɎgp̈悪cĂΊJ
			printf("webcam/free 0x%08x\n", f->data);
			free(f->data);
			f->data = 0;
			f->sec = 0;
		}

		//摜f[^擾
		PT_WAIT_UNTIL(&s->webcam, E_OK == psnd_dtq(DTQ_CAMERA, (intptr_t)"TAKE_PICTURE"));
		PT_WAIT_UNTIL(&s->webcam, E_OK == prcv_dtq(DTQ_CAMERA_ACK2, (intptr_t*)&f->data));
		PT_WAIT_UNTIL(&s->webcam, E_OK == prcv_dtq(DTQ_CAMERA_ACK2, (intptr_t*)&f->len));
	}
	PT_END(&s->webcam);
}

static PT_THREAD(form(struct httpd_state *s))
{
	char *name = s->inputbuf;
	struct httpd_fsdata_file_noconst *f = find_httpd_fsdata(name);

	PT_BEGIN(&s->form);

	if(f)
	{
		if(f->data)
		{
			//ȑOɎgp̈悪cĂΊJ
			printf("form/free 0x%08x\n", f->data);
			free(f->data);
			f->data = 0;
			f->sec = 0;
		}

		//t@C擾
		if(E_OK == snd_dtq(DTQ_FF, (intptr_t)name))
		{
			PT_WAIT_UNTIL(&s->form, E_OK == prcv_dtq(DTQ_FF_ACK, (intptr_t*)&f->data));
			PT_WAIT_UNTIL(&s->form, E_OK == prcv_dtq(DTQ_FF_ACK, (intptr_t*)&f->len));

			int data;
			char *c;

			//p݂̌̒lt@Cɏ
			if(c = strstr(f->data, "GET_PAN"))
			{
				PT_WAIT_UNTIL(&s->form, E_OK == psnd_dtq(DTQ_SERVO, (intptr_t)"GET_PAN"));
				PT_WAIT_UNTIL(&s->form, E_OK == prcv_dtq(DTQ_SERVO_ACK, (intptr_t*)&data));
				memset(c, ' ', 8);
				*(c + snprintf(c, 8, "%d", data)) = ' ';
			}

			//`ǧ݂̒lt@Cɏ
			if(c = strstr(f->data, "GET_TILT"))
			{
				PT_WAIT_UNTIL(&s->form, E_OK == psnd_dtq(DTQ_SERVO, (intptr_t)"GET_TILT"));
				PT_WAIT_UNTIL(&s->form, E_OK == prcv_dtq(DTQ_SERVO_ACK, (intptr_t*)&data));
				memset(c, ' ', 8);
				*(c + snprintf(c, 8, "%d", data)) = ' ';
			}

			//Xebv݂̌̒lt@Cɏ
			if(strstr(f->data, "CHECK1"))
			{
				PT_WAIT_UNTIL(&s->form, E_OK == psnd_dtq(DTQ_SERVO, (intptr_t)"GET_STEP"));
				PT_WAIT_UNTIL(&s->form, E_OK == prcv_dtq(DTQ_SERVO_ACK, (intptr_t*)&data));
				int n, n2d[] = {1,10,30};
				for(n = 0; n < 3; n++)
				{
					if(c = strstr(f->data, "CHECK1"))
					{
						if(n2d[n] == data)
						{
							memcpy(c, "CHECKED", 7);
						}
						else
						{
							memset(c, ' ', 7);
						}
					}
				}
			}

			//摜TCY݂̌̒lt@Cɏ
			if(strstr(f->data, "CHECK2"))
			{
				PT_WAIT_UNTIL(&s->form, E_OK == psnd_dtq(DTQ_CAMERA, (intptr_t)"GET_SIZE"));
				PT_WAIT_UNTIL(&s->form, E_OK == prcv_dtq(DTQ_CAMERA_ACK, (intptr_t*)&data));
				int n;
				for(n = 0; n < 3; n++)
				{
					char *c = strstr(f->data, "CHECK2");
					if(n == data)
					{
						memcpy(c, "CHECKED", 7);
					}
					else
					{
						memset(c, ' ', 7);
					}
				}
			}
		}
	}
	PT_END(&s->form);
}

static PT_THREAD(webcmd(struct httpd_state *s))
{
	const char *inputbuf = s->inputbuf;
	const char* p;

	PT_BEGIN(&s->webcmd);

	unsigned int data;

	if(strstr(inputbuf, "DTQ_CAMERA"))
	{
		if(p = strchr(inputbuf, '='))
		{
			printf("webcmd/snd_dtq(%s)\n", inputbuf);
			PT_WAIT_UNTIL(&s->webcmd, E_OK == psnd_dtq(DTQ_CAMERA, (intptr_t)++p));
			PT_WAIT_UNTIL(&s->webcmd, E_OK == prcv_dtq(DTQ_CAMERA_ACK3, (intptr_t*)&data));
		}
	}

	if(strstr(inputbuf, "DTQ_SERVO"))
	{
		if(p = strchr(inputbuf, '='))
		{
			printf("webcmd/snd_dtq(%s)\n", inputbuf);
			PT_WAIT_UNTIL(&s->webcmd, E_OK == psnd_dtq(DTQ_SERVO, (intptr_t)++p));
			PT_WAIT_UNTIL(&s->webcmd, E_OK == prcv_dtq(DTQ_SERVO_ACK, (intptr_t*)&data));
		}
	}
	PT_END(&s->webcmd);
}
