#include <kernel.h>
#include "kernel_cfg.h"

#include <stdio.h>
#include <stdlib.h>

#include "task_clock.h"

#include "httpd-fsdata.h"
extern struct httpd_fsdata_file_noconst * HTTPD_FS_ROOT;

static void httpd_fs_sec_count(void)
{
  struct httpd_fsdata_file_noconst *f;

  for(f = (struct httpd_fsdata_file_noconst *)HTTPD_FS_ROOT;
      f != NULL;
      f = (struct httpd_fsdata_file_noconst *)f->next) {

    if(f->data) {
      if(++(f->sec) > 60) {
        printf("task_clock/free 0x%08x %s\n", f->data, f->name);
        free(f->data);
        f->data = 0;
        f->sec = 0;
      }
    }
  }
  return;
}

void task_clock(intptr_t exinf)
{
	while(1)
	{
		wai_sem(SEM_CLOCK);
		httpd_fs_sec_count();
	}
}
