#include <kernel.h>
#include "kernel_cfg.h"

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "httpd-fsdata.h"

#include "ff.h"
#include "diskio.h"
extern WCHAR* uni2sjis;
extern int sizeof_uni2sjis;

#include "led_ctrl.h"
#include "task_ff.h"

int file_read(const char *file_name, char **buf_p, long *buf_size)
{
	FRESULT res;
	FIL fobj;
	UINT size;
	char command[32];

//	printf("task_ff/file_read %s\n", file_name);

	res = f_open(&fobj, file_name, FA_READ);
	strcpy(command, "f_open");
	if(FR_OK != res)goto error;

	*buf_size = fobj.fsize;
	*buf_p = malloc(*buf_size);
//	printf("task_ff/malloc = 0x%08x\n", *buf_p);
	if(0 == *buf_p)goto error;

	res = f_read(&fobj, *buf_p, (UINT)*buf_size, &size);
	strcpy(command, "f_read");
	if(FR_OK != res)goto error;
	if(*buf_size != size)goto error;

	res = f_close(&fobj);
	strcpy(command, "f_close");
	if(FR_OK != res)goto error;

	return 1;

error:
	printf("task_ff/file_read %s %s error %d\n", command, file_name, res);
	*buf_p = 0;
	*buf_size = 0;
	return 0;
}

void task_ff(intptr_t exinf)
{
	printf("web camera RX62N/CQ-Interface-2011\r\n");
	while(1)
	{
		if(0 == (disk_initialize(0) & (STA_NOINIT | STA_NODISK)))
		{
			FATFS fatfs;
			if(FR_OK == f_mount(0, &fatfs))
			{
				led_on();
				while(1)
				{
					unsigned int data;
					rcv_dtq(DTQ_FF, (intptr_t*)&data);
					printf("task_ff/rcv_dtq = %s\n", (char*)data);

					if(data)
					{
						char *buf_p;
						long buf_size;
						file_read((const char *)data, &buf_p, &buf_size);
						snd_dtq(DTQ_FF_ACK, (intptr_t)buf_p);
						snd_dtq(DTQ_FF_ACK, (intptr_t)buf_size);
					}
				}
			}
		}
		//printf("disk error\r\n");
		dly_tsk(1000);
		led_toggle();
	}
}
