/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2005-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: mutex.h 1910 2010-08-25 06:30:21Z ertl-hiro $
 */

/*
 *		~[ebNX@\
 */

#ifndef TOPPERS_MUTEX_H
#define TOPPERS_MUTEX_H

#include <queue.h>

/*
 *  ~[ebNXubN
 *
 *  ̍\̂́CEʐMIuWFNg̏ubN̋ʕ
 *  iWOBJINIBjgiIuWFNgw̌pɑĵŁC
 *  ŏ̃tB[hʂɂȂĂD
 */
typedef struct mutex_initialization_block {
	ATR			mtxatr;			/* ~[ebNX */
	uint_t		ceilpri;		/* ~[ebNX̏Dxi\j*/
} MTXINIB;

/*
 *  ~[ebNXǗubN
 *
 *  ̍\̂́CEʐMIuWFNg̊ǗubN̋ʕiWOBJCBj
 *  giIuWFNgw̌pɑĵŁCŏ2
 *  tB[hʂɂȂĂD
 */
typedef struct mutex_control_block {
	QUEUE		wait_queue;		/* ~[ebNX҂L[ */
	const MTXINIB *p_mtxinib;	/* ubNւ̃|C^ */
	TCB			*p_loctsk;		/* ~[ebNXbNĂ^XN */
	QUEUE		mutex_queue;	/* bNĂ~[ebNX̃L[ */
} MTXCB;

/*
 *  ~[ebNX҂ubN̒`
 *
 *  ̍\̂́CEʐMIuWFNg̑҂ubN̋ʕ
 *  iWINFO_WOBJjgiIuWFNgw̌pɑĵŁC
 *  ׂẴtB[hʂɂȂĂD
 */
typedef struct mutex_waiting_information {
	WINFO	winfo;			/* W̑҂ubN */
	MTXCB	*p_mtxcb;		/* ҂Ă~[ebNX̊ǗubN */
} WINFO_MTX;

/*
 *  ~[ebNXID̍őlikernel_cfg.cj
 */
extern const ID	tmax_mtxid;

/*
 *  ~[ebNXubÑGAikernel_cfg.cj
 */
extern const MTXINIB	mtxinib_table[];

/*
 *  ~[ebNXǗubÑGAikernel_cfg.cj
 */
extern MTXCB	mtxcb_table[];

/*
 *  ~[ebNXǗubN~[ebNXIDo߂̃}N
 */
#define	MTXID(p_mtxcb)	((ID)(((p_mtxcb) - mtxcb_table) + TMIN_MTXID))

/*
 *  ~[ebNX@\̏
 */
extern void	initialize_mutex(void);

/*
 *  Dxᔽ̃`FbN
 *
 *  chg_pri̒ŏDxᔽ̃`FbNs߂ɗp֐łC
 *  p_tcbŎw肳^XNbNĂDx~[ebNXƁC
 *  bN҂ĂDx~[ebNX̒ŁCDx
 *  bpriorityႢ̂falseCłȂtrueԂD
 */
extern bool_t	(*mtxhook_check_ceilpri)(TCB *p_tcb, uint_t bpriority);
extern bool_t	mutex_check_ceilpri(TCB *p_tcb, uint_t bpriority);

/* 
 *  Dx~[ebNXbNĂ邩̃`FbN
 *
 *  p_tcbŎw肳^XNDx~[ebNXbNĂ
 *  trueCłȂfalseԂD
 */
extern bool_t	(*mtxhook_scan_ceilmtx)(TCB *p_tcb);
extern bool_t	mutex_scan_ceilmtx(TCB *p_tcb);

/* 
 *  ^XŇݗDx̌vZ
 *
 *  p_tcbŎw肳^XŇݗDxiɐݒ肷ׂljvZD
 */
extern uint_t	mutex_calc_priority(TCB *p_tcb);

/*
 *  ~[ebNX̃bN
 *
 *  p_mtxcbŎw肳~[ebNXbNDbN
 *  ~[ebNXɁCbN҂Ԃ̃^XNꍇɂ́C̃^XN
 *  Ƀ~[ebNXbND
 */
extern bool_t	mutex_release(MTXCB *p_mtxcb);

/*
 *  ^XNbNĂ邷ׂẴ~[ebNX̃bN
 *
 *  p_tcbŎw肳^XNɁCꂪbNĂ邷ׂẴ~[ebN
 *  XbNDbN~[ebNXɁCbN҂
 *  Ԃ̃^XNꍇɂ́C̃^XNɃ~[ebNXbND
 *
 *  ̊֐́C^XN̏IɎĝł邽߁Cp_tcbŎw肳
 *  ^XN̗DxύX鏈͍sȂDC̊֐̒ő
 *  ̃^XN̗DxωCsׂ^XNς邱ƂD
 *  ߁C̊֐߂ɁCfBXpb`KvʂāCKv
 *  ꍇɂ̓fBXpb`sȂ΂ȂȂD
 */
extern bool_t	(*mtxhook_release_all)(TCB *p_tcb);
extern bool_t	mutex_release_all(TCB *p_tcb);

#endif /* TOPPERS_MUTEX_H */
