#include <kernel.h>
#include "kernel_cfg.h"

#include "iodefine.h"
#include "mtu2_ctrl.h"
#include "lcdset.h"

#if 1
//FUTABA S3003
#define WCYC (48000000/64 * 20/1000)		// 20/1000 = 20msec(PWM̎)
#define WMIN (48000000/64 *  33/100000)		//  33/100000 = 0.33msec(-90x:1.33msec - 1.00msec)
#define WMID (48000000/64 * 133/100000)		// 133/100000 = 1.33msec(0x)
#define WMAX (48000000/64 * 233/100000)		// 233/100000 = 2.33msec(+90x:1.33msec + 1.00msec)
#else
//SAVOX SC-0352
#define WCYC (48000000/64 * 20/1000)		// 20/1000 = 20msec(PWM̎)
#define WMIN (48000000/64 *  80/100000)		//  80/100000 = 0.80msec(-90x:1.50msec - 0.70msec)
#define WMID (48000000/64 * 150/100000)		// 150/100000 = 1.50msec(0x)
#define WMAX (48000000/64 * 220/100000)		// 220/100000 = 2.20msec(+90x:1.50msec + 0.70msec)
#endif

void init_mtu3(void)
{
	MSTP_MTU3 = 0;
	return;
}

void init_mtu4(void)
{
	MSTP_MTU4 = 0;
	return;
}

void mtu3_set(short v)
{
	PORT7.DR.BIT.B0 = 0;
	ICU.IER[IER_MTU3_TGIC3].BIT.IEN_MTU3_TGIC3 = 0;	// Disable TGIC3 

	MTUA.TSTR.BIT.CST3 = 0;			//JEg~
	IOPORT.PFCMTU.BIT.MTUS2 = 1;	//P56MTIOC3C-B[qƂđI

	MTU3.TCR.BIT.TPSC = 3;			//^C}vXP[I/ PCLK/64
	MTU3.TCR.BIT.CKEG = 0;			//NbNGbWI
	MTU3.TCR.BIT.CCLR = 6;			//JE^NAvI/TGRD̃RyA}b`
	MTU3.TMDR.BIT.MD = 2;			//샂[h/PWM[hP
	MTU3.TIORL.BIT.IOC = 1;			//I/ORg[Crbg/LCLo
	MTU3.TIORL.BIT.IOD = 2;			//I/ORg[Drbg/LCHo
	MTU3.TGRC = WMID;
	MTU3.TGRD = WCYC;
	MTU3.TCNT = 0;

	MTU3.TGRC = (90 - v) * (WMAX - WMIN)/90/2 + WMIN;	//WMAX`WMIN}90xvŎw
	MTUA.TSTR.BIT.CST3 = 1;
	return;
}

void mtu4_set(short v)
{
	PORT7.DR.BIT.B0 = 0;
	ICU.IER[IER_MTU4_TGIC4].BIT.IEN_MTU4_TGIC4 = 0;	// Disable TGIC4 

	MTUA.TSTR.BIT.CST4 = 0;			//JEg~
//	MTUA.TOER.BIT.OE4C = 1;			//MTIOC4Co͋
	MTUA.TOER.BYTE = 0x12;			//MTIOC4C/4Ao͋
	IOPORT.PFCMTU.BIT.MTUS4 = 0;	//P25MTIOC4C-A[qƂđI

	MTU4.TCR.BIT.TPSC = 3;			//^C}vXP[I/ PCLK64
	MTU4.TCR.BIT.CKEG = 0;			//NbNGbWI
	MTU4.TCR.BIT.CCLR = 6;			//JE^NAvI/TGRD̃RyA}b`
	MTU4.TMDR.BIT.MD = 2;			//샂[h/PWM[hP
	MTU4.TIORL.BIT.IOC = 1;			//I/ORg[Crbg/LCLo
	MTU4.TIORL.BIT.IOD = 2;			//I/ORg[Drbg/LCHo
	MTU4.TGRC = WMID;
	MTU4.TGRD = WCYC;
	MTU4.TCNT = 0;

	MTU4.TGRC = (90 - v) * (WMAX - WMIN)/90/2 + WMIN;	//WMAX`WMIN}90xvŎw
	MTUA.TSTR.BIT.CST4 = 1;
	return;
}

void mtu34_stop(void)
{
	MTUA.TSTR.BYTE = 0;
	//for start trigger EXDMAC 
	//LCD_DEMɘAEXDMACNA\f[^]
	MTU1.TCR.BYTE = 0x20;					// PCLK CCLR=TGRA
	MTU1.TGRA = LCD_HC * PCLK/LCD_CLK -1;	// RyA}b`EXDMACN
	MTU1.TGRB = LCD_HC * PCLK/LCD_CLK -4;	// RyA}b`Ŋ荞ݏɓOoX~AEXDMAC̋NזȂ
	MTU1.TCNT = (LCD_HC - LCD_HBP + 1) * PCLK/LCD_CLK;	// Y
	ICU.IER[IER_MTU1_TGIB1].BIT.IEN_MTU1_TGIB1 = 1;	// Enable TGIEB 
	ICU.IPR[IPR_MTU1_TGIB1].BYTE = 15;		// Set interrupt priority level
	
	//for display enable and nHSYNC 
	MTU3.TCR.BYTE = 0xa0;					// PCLK CCLR=TGRC
	MTU3.TMDR.BYTE = 0x02;					// PWM1 no-Buffer
	MTU3.TIER.BYTE = 0x01;					// TGIA荞݋
	MTU3.TIORH.BYTE = 0x66;					// mANeBuH
	MTU3.TIORL.BYTE = 0x25;					// ANeBuL
	MTU3.TGRC = LCD_HC * PCLK/LCD_CLK -1;	// HSYNC
	MTU3.TGRD = LCD_HS * PCLK/LCD_CLK -1;	//
	MTU3.TGRA = (LCD_HBP + LCD_HD) * PCLK/LCD_CLK -1;	//DE
	MTU3.TGRB = LCD_HBP * PCLK/LCD_CLK -1;	//
	MTU3.TCNT = 0; 
	IOPORT.PFCMTU.BYTE = 0x04;				// MIOC3C-B[qI
	ICU.IER[IER_MTU3_TGIA3].BIT.IEN_MTU3_TGIA3 = 1;	// Enable TGIEA 
	ICU.IPR[IPR_MTU3_TGIA3].BYTE = 15;		// 荞ݗDx=15
	
	//for LCD dot clock
	MTU4.TCR.BYTE = 0x20;					// PCLK CCLR=TGRA
	MTU4.TMDR.BYTE = 0x02;					// PWM1
	MTU4.TIORH.BYTE = 0x25;					// LX^[g
	MTU4.TGRA = PCLK/LCD_CLK - 1;			// PCLK/6=8MHz
	MTU4.TGRB = PCLK/LCD_CLK/2 - 1;			//
	MTU4.TCNT = 0; 
//	MTUA.TOER.BYTE = 0x02; 					// MTIOC4A[qL 
	MTUA.TOER.BYTE = 0x12; 					// MTIOC4A/4C[qL 
	
	//for VSYNC
	PPG0.NDERL.BYTE = 0x08;					// PO3gp
	PPG0.PODRL.BYTE = 0x08;					// Ho
	PPG0.NDRL.BYTE = 0x08;					// 
	PPG0.PCR.BYTE = 0xff;					// m[}[hAMTU3gK
		

	EXDMAC0.EDMSAR = (void *)0x04000000;	// \JnCS4̈̐擪
	EXDMAC0.EDMDAR = (void *)0x08000000;	// OԂȂǂłOK(VOAhX)
	EXDMAC0.EDMCRA = (LCD_HD <<16) + LCD_HD;	// 320hbgPubNƂ
	EXDMAC0.EDMCRB = LCD_VD;				// 240ubN̓]
	EXDMAC0.EDMTMD.WORD = 0x8103;			// ubN][hAMTU1v
	EXDMAC0.EDMAMD.LONG = 0x00028000;		// VOAhXA]̓CNgA]͌Œ
	EXDMAC0.EDMCNT.BYTE = 1;				// `l0Cl[u
	EXDMAC.EDMAST.BYTE = 1;					// }X^Cl[u
	
	MTUA.TSTR.BYTE = 0xc2;					// Strat MTU1,3,4

	//LCD back light ON
	PORT7.DDR.BYTE = 0x01;	
	PORT7.DR.BIT.B0 = 1;
	
	return;
}
