#include <kernel.h>
#include "kernel_cfg.h"

#include "iodefine.h"
#include "typedefine.h"

#include "rtc_ctrl.h"

void init_rtc(void)
{
	RTC.RCR2.BIT.START = 0;
	while(RTC.RCR2.BIT.START);

	RTC.RCR2.BIT.RESET = 1;
	while(RTC.RCR2.BIT.RESET);

	RTC.RCR2.BIT.START = 1;
	while(RTC.RCR2.BIT.START == 0);

	RTC.RCR1.BIT.PES = 6;	//荞ݔ̎PbƂɂ
	RTC.RCR1.BIT.PIE = 1;	//荞݂v
	IPR(RTC, PRD) = 1;		//荞ݗD惌x=1
	IEN(RTC, PRD) = 1;		//荞݋
	return;
}

static int int2bcd(int i)
{
	return (int)((((i /1000) % 10) << 12) | (((i /100) % 10) << 8) | (((i /10) % 10) << 4) | (i % 10));
}

void rtc_set(int year, int mon, int mday, int hour, int min, int sec)
{
	RTC.RCR2.BIT.START = 0;
	while(RTC.RCR2.BIT.START);

	RTC.RCR2.BIT.RESET = 1;
	while(RTC.RCR2.BIT.RESET);

	RTC.RYRCNT.WORD		= (unsigned short)int2bcd(year);
	RTC.RMONCNT.BYTE	= (unsigned char)int2bcd(mon);
	RTC.RDAYCNT.BYTE	= (unsigned char)int2bcd(mday);
	RTC.RHRCNT.BYTE		= (unsigned char)int2bcd(hour);
	RTC.RMINCNT.BYTE	= (unsigned char)int2bcd(min);
	RTC.RSECCNT.BYTE	= (unsigned char)int2bcd(sec);

	RTC.RCR2.BIT.START = 1;
	while(RTC.RCR2.BIT.START == 0);
	return;
}

static int bcd2int(unsigned int b)
{
	return ((((b >> 12) & 0x0f) * 1000) + (((b >> 8) & 0x0f) * 100) + (((b >> 4) & 0x0f) * 10) + (b & 0x0f));
}

void rtc_get(int* year, int* mon, int* mday, int* hour, int* min, int* sec)
{
	{
		*year	= bcd2int((unsigned int)RTC.RYRCNT.WORD);
		*mon	= bcd2int((unsigned int)RTC.RMONCNT.BYTE);
		*mday	= bcd2int((unsigned int)RTC.RDAYCNT.BYTE);
		*hour	= bcd2int((unsigned int)RTC.RHRCNT.BYTE);
		*min	= bcd2int((unsigned int)RTC.RMINCNT.BYTE);
		*sec	= bcd2int((unsigned int)RTC.RSECCNT.BYTE);
	}
	return;
}

void rtc_int_sec(intptr_t exinf)
{
	ipsnd_dtq(DTQ_CALENDER, (intptr_t)0);
	isig_sem(SEM_CLOCK);
	return;
}
